---
sidebar_position: 1
sidebar_label: 2025
---

# 2025 Changelog

### ClickHouse release v24.11.4.45-stable (074a009b2a7) FIXME as compared to v24.11.3.66-stable (01b8a197a87)

#### Improvement
* Backported in [#74903](https://github.com/ClickHouse/ClickHouse/issues/74903): Improve performance of larger multi requests in Keeper. [#74849](https://github.com/ClickHouse/ClickHouse/pull/74849) ([Antonio Andelic](https://github.com/antonio2368)).

#### Bug Fix (user-visible misbehavior in an official stable release)
* Backported in [#74821](https://github.com/ClickHouse/ClickHouse/issues/74821): Fix rare crash in refreshable materialized view during server shutdown. [#73323](https://github.com/ClickHouse/ClickHouse/pull/73323) ([Michael Kolupaev](https://github.com/al13n321)).
* Backported in [#74808](https://github.com/ClickHouse/ClickHouse/issues/74808): Fix security issue to prevent SQL injection in postgresql and sqlite table functions. [#74144](https://github.com/ClickHouse/ClickHouse/pull/74144) ([Pablo Marcos](https://github.com/pamarcos)).
* Backported in [#75122](https://github.com/ClickHouse/ClickHouse/issues/75122): Fix crash when inserting interval (issue [#74299](https://github.com/ClickHouse/ClickHouse/issues/74299)). [#74478](https://github.com/ClickHouse/ClickHouse/pull/74478) ([NamHoaiNguyen](https://github.com/NamHoaiNguyen)).
* Backported in [#75095](https://github.com/ClickHouse/ClickHouse/issues/75095): Fixed `INSERT SELECT` queries between tables with `Tuple` columns and enabled sparse serialization. [#74698](https://github.com/ClickHouse/ClickHouse/pull/74698) ([Anton Popov](https://github.com/CurtizJ)).
* Backported in [#75307](https://github.com/ClickHouse/ClickHouse/issues/75307): Fix crash during JSON type declaration parsing when type name is not uppercase. [#74784](https://github.com/ClickHouse/ClickHouse/pull/74784) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#74906](https://github.com/ClickHouse/ClickHouse/issues/74906): Keeper fix: fix reading log entries from disk. [#74785](https://github.com/ClickHouse/ClickHouse/pull/74785) ([Antonio Andelic](https://github.com/antonio2368)).
* Backported in [#75170](https://github.com/ClickHouse/ClickHouse/issues/75170): Fix missing `used_privileges` and `missing_privileges` fields in `query_log` for BACKUP and RESTORE operations. [#74887](https://github.com/ClickHouse/ClickHouse/pull/74887) ([Alexey Katsman](https://github.com/alexkats)).
* Backported in [#74955](https://github.com/ClickHouse/ClickHouse/issues/74955): Fix FILE_DOESNT_EXIST error occurring during data parts merge for a table with an empty column in Azure Blob Storage. [#74892](https://github.com/ClickHouse/ClickHouse/pull/74892) ([Julia Kartseva](https://github.com/jkartseva)).
* Backported in [#75052](https://github.com/ClickHouse/ClickHouse/issues/75052): HDFS refresh krb ticket if sasl error during hdfs select request. [#74930](https://github.com/ClickHouse/ClickHouse/pull/74930) ([inv2004](https://github.com/inv2004)).
* Backported in [#75412](https://github.com/ClickHouse/ClickHouse/issues/75412): Revert part's state from deleting back to outdated when remove operation has failed. [#74985](https://github.com/ClickHouse/ClickHouse/pull/74985) ([Sema Checherinda](https://github.com/CheSema)).
* Backported in [#75405](https://github.com/ClickHouse/ClickHouse/issues/75405): Fixed usage of indexes (primary and secondary) for `Array`, `Map` and `Nullable(..)` columns with enabled setting `optimize_function_to_subcolumns`. Previously, indexes for these columns could have been ignored. [#75081](https://github.com/ClickHouse/ClickHouse/pull/75081) ([Anton Popov](https://github.com/CurtizJ)).
* Backported in [#75458](https://github.com/ClickHouse/ClickHouse/issues/75458): Fix the crash bug of CTE with Insert. [#75188](https://github.com/ClickHouse/ClickHouse/pull/75188) ([Shichao Jin](https://github.com/jsc0218)).
* Backported in [#75481](https://github.com/ClickHouse/ClickHouse/issues/75481): Hide sensitive info for `icebergS3`, `icebergAzure` table functions and table engines. [#75378](https://github.com/ClickHouse/ClickHouse/pull/75378) ([Kseniia Sumarokova](https://github.com/kssenii)).

#### Build/Testing/Packaging Improvement
* Backported in [#75287](https://github.com/ClickHouse/ClickHouse/issues/75287): Improvement to set even more restrictive defaults. The current defaults are already secure - the user has to specify an option to publish ports explicitly. But when the `default` user doesn’t have a password set by `CLICKHOUSE_PASSWORD` and/or a username changed by `CLICKHOUSE_USER` environment variables, it should be available only from the local system as an additional level of protection. [#75259](https://github.com/ClickHouse/ClickHouse/pull/75259) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).

#### NOT FOR CHANGELOG / INSIGNIFICANT

* Backported in [#75138](https://github.com/ClickHouse/ClickHouse/issues/75138): send logs and InsertProfileEvents for each block even for async insert. [#73915](https://github.com/ClickHouse/ClickHouse/pull/73915) ([Sema Checherinda](https://github.com/CheSema)).
* Backported in [#74766](https://github.com/ClickHouse/ClickHouse/issues/74766): Avoid special PR packet processing if PR is disabled. [#74402](https://github.com/ClickHouse/ClickHouse/pull/74402) ([Igor Nikonov](https://github.com/devcrafter)).
* Backported in [#74927](https://github.com/ClickHouse/ClickHouse/issues/74927): Fix calculation of metrics `BackupsThreadsActive` and `RestoreThreadsActive`. Those metrics were not updated before this PR. [#74456](https://github.com/ClickHouse/ClickHouse/pull/74456) ([Vitaly Baranov](https://github.com/vitlibar)).
* Backported in [#74685](https://github.com/ClickHouse/ClickHouse/issues/74685): A follow-up for [#74399](https://github.com/ClickHouse/ClickHouse/issues/74399), send the event as early as possible. [#74666](https://github.com/ClickHouse/ClickHouse/pull/74666) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).
* Backported in [#75345](https://github.com/ClickHouse/ClickHouse/issues/75345): Tests: add 'error' test hint for functional tests. [#75158](https://github.com/ClickHouse/ClickHouse/pull/75158) ([Nikita Fomichev](https://github.com/fm4v)).
* Backported in [#75369](https://github.com/ClickHouse/ClickHouse/issues/75369): Relax active parts filter. [#75265](https://github.com/ClickHouse/ClickHouse/pull/75265) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Backported in [#75330](https://github.com/ClickHouse/ClickHouse/issues/75330): Add option to skip user setup in entrypoint.sh. [#75316](https://github.com/ClickHouse/ClickHouse/pull/75316) ([Nikita Fomichev](https://github.com/fm4v)).

