---
sidebar_position: 1
sidebar_label: 2025
---

# 2025 Changelog

### ClickHouse release v24.12.3.47-stable (d5d8b06f0da) FIXME as compared to v24.12.2.29-stable (e06743658c1)

#### New Feature
* Backported in [#74319](https://github.com/ClickHouse/ClickHouse/issues/74319): When `min_age_to_force_merge_seconds` and `min_age_to_force_merge_on_partition_only` are both enabled, the part merging will ignore the max bytes limit. [#73656](https://github.com/ClickHouse/ClickHouse/pull/73656) ([Kai Zhu](https://github.com/nauu)).

#### Improvement
* Backported in [#74077](https://github.com/ClickHouse/ClickHouse/issues/74077): Allow to alter commit settings in storage S3(Azure)Queue. (Commit settings are: max_processed_files_before_commit, max_processed_rows_before_commit, max_processed_bytes_before_commit, max_processing_time_sec_before_commit). [#73635](https://github.com/ClickHouse/ClickHouse/pull/73635) ([Kseniia Sumarokova](https://github.com/kssenii)).

#### Bug Fix (user-visible misbehavior in an official stable release)
* Backported in [#74160](https://github.com/ClickHouse/ClickHouse/issues/74160): Avoid pause after `ALTER TABLE REPLACE/MOVE PARTITION FROM/TO TABLE`. Retrieve correct settings for background task scheduling. [#72024](https://github.com/ClickHouse/ClickHouse/pull/72024) ([Aleksei Filatov](https://github.com/aalexfvk)).
* Backported in [#74143](https://github.com/ClickHouse/ClickHouse/issues/74143): Propagate format settings to NativeWriter in TCPHandler, so settings like `output_format_native_write_json_as_string` are applied correctly. [#73179](https://github.com/ClickHouse/ClickHouse/pull/73179) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#73895](https://github.com/ClickHouse/ClickHouse/issues/73895): Fix preparing for squashin for Dynamic and JSON columns. Previously in some cases new types could be inserted into shared variant/shared data even when the limit on types/paths is not reached. [#73388](https://github.com/ClickHouse/ClickHouse/pull/73388) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#74441](https://github.com/ClickHouse/ClickHouse/issues/74441): Fixes segfault when the source of the dictionary contains a function with wrong data. [#73535](https://github.com/ClickHouse/ClickHouse/pull/73535) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Backported in [#73799](https://github.com/ClickHouse/ClickHouse/issues/73799): Fix possible data inconsistency in Dynamic column. Fixes possible logical error `Nested columns sizes are inconsistent with local_discriminators column size`. [#73644](https://github.com/ClickHouse/ClickHouse/pull/73644) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#74029](https://github.com/ClickHouse/ClickHouse/issues/74029): Fix deserialization of Dynamic/Object structure. It could lead to CANNOT_READ_ALL_DATA exceptions. [#73767](https://github.com/ClickHouse/ClickHouse/pull/73767) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#74100](https://github.com/ClickHouse/ClickHouse/issues/74100): Fixes [#72078](https://github.com/ClickHouse/ClickHouse/issues/72078) ( S3 Express Support was broken ). [#73777](https://github.com/ClickHouse/ClickHouse/pull/73777) ([Sameer Tamsekar](https://github.com/stamsekar)).
* Backported in [#74092](https://github.com/ClickHouse/ClickHouse/issues/74092): Fix implicit privileges (worked as wildcard before). [#73932](https://github.com/ClickHouse/ClickHouse/pull/73932) ([Azat Khuzhin](https://github.com/azat)).
* Backported in [#74044](https://github.com/ClickHouse/ClickHouse/issues/74044): Fix high memory usage during nested Maps creation. [#73982](https://github.com/ClickHouse/ClickHouse/pull/73982) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#74057](https://github.com/ClickHouse/ClickHouse/issues/74057): Fix: alias can be not added to the projection if it is referenced by another alias and selected in inverse order. [#74033](https://github.com/ClickHouse/ClickHouse/pull/74033) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Backported in [#74110](https://github.com/ClickHouse/ClickHouse/issues/74110): A disk using the plain_rewritable metadata can be shared among multiple server instances. It is expected for one instance to read a metadata object while another modifies it. Object not found errors are ignored during plain_rewritable initialization with Azure storage, similar to the behavior implemented for S3. [#74059](https://github.com/ClickHouse/ClickHouse/pull/74059) ([Julia Kartseva](https://github.com/jkartseva)).
* Backported in [#74136](https://github.com/ClickHouse/ClickHouse/issues/74136): Fixes case when the user specifies keyword arguments in the kafka table engine. [#74064](https://github.com/ClickHouse/ClickHouse/pull/74064) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Backported in [#74179](https://github.com/ClickHouse/ClickHouse/issues/74179): Fix crash when reading a subcolumn from the compressed Memory engine table. Fixes [#74009](https://github.com/ClickHouse/ClickHouse/issues/74009). [#74161](https://github.com/ClickHouse/ClickHouse/pull/74161) ([Nikita Taranov](https://github.com/nickitat)).

#### NOT FOR CHANGELOG / INSIGNIFICANT

* Backported in [#73643](https://github.com/ClickHouse/ClickHouse/issues/73643): Follow-up for https://github.com/ClickHouse/ClickHouse/pull/71095. [#73196](https://github.com/ClickHouse/ClickHouse/pull/73196) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Backported in [#73672](https://github.com/ClickHouse/ClickHouse/issues/73672): Add a setting. [#73281](https://github.com/ClickHouse/ClickHouse/pull/73281) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Backported in [#73792](https://github.com/ClickHouse/ClickHouse/issues/73792): Fix if condition in [#63151](https://github.com/ClickHouse/ClickHouse/issues/63151). [#73504](https://github.com/ClickHouse/ClickHouse/pull/73504) ([Andrey Zvonov](https://github.com/zvonand)).
* Backported in [#74301](https://github.com/ClickHouse/ClickHouse/issues/74301): Better error message when applying row policy. [#73739](https://github.com/ClickHouse/ClickHouse/pull/73739) ([Alexander Tokmakov](https://github.com/tavplubix)).
* Backported in [#74020](https://github.com/ClickHouse/ClickHouse/issues/74020): Revert [#72490](https://github.com/ClickHouse/ClickHouse/issues/72490) because the new `MergeTreeIndexGranularityInternalArraysTotalSize` metric is incorrect. [#73740](https://github.com/ClickHouse/ClickHouse/pull/73740) ([Alexander Tokmakov](https://github.com/tavplubix)).
* Backported in [#74465](https://github.com/ClickHouse/ClickHouse/issues/74465): Make `version_helper` populated from every commit. [#74399](https://github.com/ClickHouse/ClickHouse/pull/74399) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).

