---
sidebar_position: 1
sidebar_label: 2025
---

# 2025 Changelog

### ClickHouse release v24.12.4.49-stable (2fcb11ae032) FIXME as compared to v24.12.3.47-stable (d5d8b06f0da)

#### Improvement
* Backported in [#74905](https://github.com/ClickHouse/ClickHouse/issues/74905): Improve performance of larger multi requests in Keeper. [#74849](https://github.com/ClickHouse/ClickHouse/pull/74849) ([Antonio Andelic](https://github.com/antonio2368)).

#### Bug Fix (user-visible misbehavior in an official stable release)
* Backported in [#74823](https://github.com/ClickHouse/ClickHouse/issues/74823): Fix rare crash in refreshable materialized view during server shutdown. [#73323](https://github.com/ClickHouse/ClickHouse/pull/73323) ([Michael Kolupaev](https://github.com/al13n321)).
* Backported in [#74381](https://github.com/ClickHouse/ClickHouse/issues/74381): Fixed `NOT_FOUND_COLUMN_IN_BLOCK` in queries with `FINAL` and `SAMPLE`. Fixed incorrect result in selects with `FINAL` from `CollapsingMergeTree` and enabled optimizations of `FINAL` . [#73682](https://github.com/ClickHouse/ClickHouse/pull/73682) ([Anton Popov](https://github.com/CurtizJ)).
* Backported in [#74810](https://github.com/ClickHouse/ClickHouse/issues/74810): Fix security issue to prevent SQL injection in postgresql and sqlite table functions. [#74144](https://github.com/ClickHouse/ClickHouse/pull/74144) ([Pablo Marcos](https://github.com/pamarcos)).
* Backported in [#74392](https://github.com/ClickHouse/ClickHouse/issues/74392): Fix logical error in s3queue during setting file as failed. [#74216](https://github.com/ClickHouse/ClickHouse/pull/74216) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Backported in [#75124](https://github.com/ClickHouse/ClickHouse/issues/75124): Fix crash when inserting interval (issue [#74299](https://github.com/ClickHouse/ClickHouse/issues/74299)). [#74478](https://github.com/ClickHouse/ClickHouse/pull/74478) ([NamHoaiNguyen](https://github.com/NamHoaiNguyen)).
* Backported in [#75097](https://github.com/ClickHouse/ClickHouse/issues/75097): Fixed `INSERT SELECT` queries between tables with `Tuple` columns and enabled sparse serialization. [#74698](https://github.com/ClickHouse/ClickHouse/pull/74698) ([Anton Popov](https://github.com/CurtizJ)).
* Backported in [#75309](https://github.com/ClickHouse/ClickHouse/issues/75309): Fix crash during JSON type declaration parsing when type name is not uppercase. [#74784](https://github.com/ClickHouse/ClickHouse/pull/74784) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#74869](https://github.com/ClickHouse/ClickHouse/issues/74869): Keeper fix: fix reading log entries from disk. [#74785](https://github.com/ClickHouse/ClickHouse/pull/74785) ([Antonio Andelic](https://github.com/antonio2368)).
* Backported in [#75076](https://github.com/ClickHouse/ClickHouse/issues/75076): Fix missing `used_privileges` and `missing_privileges` fields in `query_log` for BACKUP and RESTORE operations. [#74887](https://github.com/ClickHouse/ClickHouse/pull/74887) ([Alexey Katsman](https://github.com/alexkats)).
* Backported in [#74957](https://github.com/ClickHouse/ClickHouse/issues/74957): Fix FILE_DOESNT_EXIST error occurring during data parts merge for a table with an empty column in Azure Blob Storage. [#74892](https://github.com/ClickHouse/ClickHouse/pull/74892) ([Julia Kartseva](https://github.com/jkartseva)).
* Backported in [#75054](https://github.com/ClickHouse/ClickHouse/issues/75054): HDFS refresh krb ticket if sasl error during hdfs select request. [#74930](https://github.com/ClickHouse/ClickHouse/pull/74930) ([inv2004](https://github.com/inv2004)).
* Backported in [#75413](https://github.com/ClickHouse/ClickHouse/issues/75413): Revert part's state from deleting back to outdated when remove operation has failed. [#74985](https://github.com/ClickHouse/ClickHouse/pull/74985) ([Sema Checherinda](https://github.com/CheSema)).
* Backported in [#75463](https://github.com/ClickHouse/ClickHouse/issues/75463): Fix the crash bug of CTE with Insert. [#75188](https://github.com/ClickHouse/ClickHouse/pull/75188) ([Shichao Jin](https://github.com/jsc0218)).

#### Build/Testing/Packaging Improvement
* Backported in [#75289](https://github.com/ClickHouse/ClickHouse/issues/75289): Improvement to set even more restrictive defaults. The current defaults are already secure - the user has to specify an option to publish ports explicitly. But when the `default` user doesn’t have a password set by `CLICKHOUSE_PASSWORD` and/or a username changed by `CLICKHOUSE_USER` environment variables, it should be available only from the local system as an additional level of protection. [#75259](https://github.com/ClickHouse/ClickHouse/pull/75259) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).

#### NOT FOR CHANGELOG / INSIGNIFICANT

* Backported in [#75140](https://github.com/ClickHouse/ClickHouse/issues/75140): send logs and InsertProfileEvents for each block even for async insert. [#73915](https://github.com/ClickHouse/ClickHouse/pull/73915) ([Sema Checherinda](https://github.com/CheSema)).
* Backported in [#74767](https://github.com/ClickHouse/ClickHouse/issues/74767): Avoid special PR packet processing if PR is disabled. [#74402](https://github.com/ClickHouse/ClickHouse/pull/74402) ([Igor Nikonov](https://github.com/devcrafter)).
* Backported in [#74929](https://github.com/ClickHouse/ClickHouse/issues/74929): Fix calculation of metrics `BackupsThreadsActive` and `RestoreThreadsActive`. Those metrics were not updated before this PR. [#74456](https://github.com/ClickHouse/ClickHouse/pull/74456) ([Vitaly Baranov](https://github.com/vitlibar)).
* Backported in [#74687](https://github.com/ClickHouse/ClickHouse/issues/74687): A follow-up for [#74399](https://github.com/ClickHouse/ClickHouse/issues/74399), send the event as early as possible. [#74666](https://github.com/ClickHouse/ClickHouse/pull/74666) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).
* Backported in [#74744](https://github.com/ClickHouse/ClickHouse/issues/74744): Review compatibility settings for 24.12 release. [#74670](https://github.com/ClickHouse/ClickHouse/pull/74670) ([Nikita Fomichev](https://github.com/fm4v)).
* Backported in [#75114](https://github.com/ClickHouse/ClickHouse/issues/75114): Add a description for `skip_redundant_aliases_in_udf` setting. [#75014](https://github.com/ClickHouse/ClickHouse/pull/75014) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Backported in [#75347](https://github.com/ClickHouse/ClickHouse/issues/75347): Tests: add 'error' test hint for functional tests. [#75158](https://github.com/ClickHouse/ClickHouse/pull/75158) ([Nikita Fomichev](https://github.com/fm4v)).
* Backported in [#75371](https://github.com/ClickHouse/ClickHouse/issues/75371): Relax active parts filter. [#75265](https://github.com/ClickHouse/ClickHouse/pull/75265) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Backported in [#75332](https://github.com/ClickHouse/ClickHouse/issues/75332): Add option to skip user setup in entrypoint.sh. [#75316](https://github.com/ClickHouse/ClickHouse/pull/75316) ([Nikita Fomichev](https://github.com/fm4v)).

