---
sidebar_position: 1
sidebar_label: 2025
---

# 2025 Changelog

### ClickHouse release v25.1.3.23-stable (5fc2cf71991) FIXME as compared to v25.1.2.3-stable (68f81366c3d)

#### Bug Fix (user-visible misbehavior in an official stable release)
* Backported in [#75311](https://github.com/ClickHouse/ClickHouse/issues/75311): Fix crash during JSON type declaration parsing when type name is not uppercase. [#74784](https://github.com/ClickHouse/ClickHouse/pull/74784) ([Pavel Kruglov](https://github.com/Avogar)).
* Backported in [#75253](https://github.com/ClickHouse/ClickHouse/issues/75253): Revert part's state from deleting back to outdated when remove operation has failed. [#74985](https://github.com/ClickHouse/ClickHouse/pull/74985) ([Sema Checherinda](https://github.com/CheSema)).
* Backported in [#75409](https://github.com/ClickHouse/ClickHouse/issues/75409): Fixed usage of indexes (primary and secondary) for `Array`, `Map` and `Nullable(..)` columns with enabled setting `optimize_function_to_subcolumns`. Previously, indexes for these columns could have been ignored. [#75081](https://github.com/ClickHouse/ClickHouse/pull/75081) ([Anton Popov](https://github.com/CurtizJ)).
* Backported in [#75461](https://github.com/ClickHouse/ClickHouse/issues/75461): Fix the crash bug of CTE with Insert. [#75188](https://github.com/ClickHouse/ClickHouse/pull/75188) ([Shichao Jin](https://github.com/jsc0218)).

#### Build/Testing/Packaging Improvement
* Backported in [#75291](https://github.com/ClickHouse/ClickHouse/issues/75291): Improvement to set even more restrictive defaults. The current defaults are already secure - the user has to specify an option to publish ports explicitly. But when the `default` user doesn’t have a password set by `CLICKHOUSE_PASSWORD` and/or a username changed by `CLICKHOUSE_USER` environment variables, it should be available only from the local system as an additional level of protection. [#75259](https://github.com/ClickHouse/ClickHouse/pull/75259) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).

#### NOT FOR CHANGELOG / INSIGNIFICANT

* Backported in [#75349](https://github.com/ClickHouse/ClickHouse/issues/75349): Tests: add 'error' test hint for functional tests. [#75158](https://github.com/ClickHouse/ClickHouse/pull/75158) ([Nikita Fomichev](https://github.com/fm4v)).
* Backported in [#75272](https://github.com/ClickHouse/ClickHouse/issues/75272): Do not ask for auth prematurally in the Play UI. [#75183](https://github.com/ClickHouse/ClickHouse/pull/75183) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Backported in [#75373](https://github.com/ClickHouse/ClickHouse/issues/75373): Relax active parts filter. [#75265](https://github.com/ClickHouse/ClickHouse/pull/75265) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Backported in [#75335](https://github.com/ClickHouse/ClickHouse/issues/75335): Add option to skip user setup in entrypoint.sh. [#75316](https://github.com/ClickHouse/ClickHouse/pull/75316) ([Nikita Fomichev](https://github.com/fm4v)).
* Backported in [#75442](https://github.com/ClickHouse/ClickHouse/issues/75442): Better exception message. [#75354](https://github.com/ClickHouse/ClickHouse/pull/75354) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Backported in [#75431](https://github.com/ClickHouse/ClickHouse/issues/75431): s3queue: do not throw exception about duplicated settings on attach. [#75355](https://github.com/ClickHouse/ClickHouse/pull/75355) ([Kseniia Sumarokova](https://github.com/kssenii)).

